/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJEventListener.h,v 1.7 1999/07/28 06:01:56 hiranabe Exp $
 */
#if !defined(TJEventListener_h)
#define TJEventListener_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

/**
 * CxgXi.
 *
 * eCxg̃Xi(M)̎x邽߂̃ev[głC
 * Cxg^ƂĂDEventSource ƑgŁCJava ̃Cxgf
 * java.util.EventObject / java.util.EventListener T|[gD
 *
 * C++ ̃ev[gƂ Event ߁C\bh̑d`𗘗pāC
 * ׂẴCxg\bh́CeventHappend ƂOɂȂD
 *
 * Cxg\bh eventHappened()  pure virtual łC^tF[X
 * ݂̂̋KDAvP[VŎR[obNłD
 *
 * gṕCTJEventSource D
 *
 * [bNj]
 *
 * ̃NX́C}`XbhɊւ郍bNSӎȂD
 * Kvł TJSafeEventListener D
 *
 * eventHappened() ̓Xbh̐݌vɂˑ邪Cʂɂ͔񓯊ďȏ΍
 * Kvł(Ƃ UNIX ̃VOinhAzD)
 * ̃NX܂̓TuNX̃IuWFNgŃ}`XbhłSɃIu
 * WFNg삵 TJSafeEventListener  TJSafeEventSource gƁD
 *
 * @author tokui
 * @date 1999,3/31
 * @see TJSafeEventListener
 * @see TJEventSource
 */
template<class EventType> class TJEventListener {
public:
    /**
     * fXgN^.
     */
	virtual ~TJEventListener() { }

    /**
     * 
     * XbhZ[tȂ̂ǂ̌.
     *
     * ̃NXgł false łD
     * EventSource  fireEvent sہC̃\bh
     * ̕Ԃlɉ eventHappend/safeEvnetHappend ĂѕD
     *
     * @return true XbhZ[t
     */
	virtual bool isSafe() { return false; }

    /*
     * CxgÑR[obN.
     *
     * @param ev CxgIuWFNg
     */
	virtual void eventHappened(const EventType& ev) = 0;

};


#endif	/* !defined(TJEventListener_h) */
