#if !defined(TJMFCThread_h)
#define TJMFCThread_h


#include "TJThread.h"
#include "TJWinThread.h"


/**
 * TJThread  MFC ɑΉ邽߂̃NX.
 *
 * MFC gEBhE̗LɊւ炸Xbh CWinThread ̃TuNX
 * łȂ΂ȂȂ. ̓ʂȎdlɑΉ邽 ThreadJack ł TJThread
 * ̃TuNX TJMFCThread 񋟂.
 *
 * ̃NX TJWinThread ɂ CWinThread ̃I[oCh\ȃ\bh
 *  TJMFCThread ̓Õ\bhɐU CWinThread ̋@\I[
 * oCh.
 * ̂悤 TJWinThread Ƌ CWinThread Ƃ̋n
 * 邽 CWinThread ̃I[oCh\ȃ\bhoƂ.
 *
 * ̃NX TJMFCThread 
 *   MFC g[JXbh (EBhEȂXbh)
 *   TJMFCGUIThread (EBhEXbh̃X[pNX)
 * ̃X[pNXƂĂ̗pz肵Ă.
 *
 * [JXbhł InitInstance(), ExitInstance(), ... ͌ĂяoȂ.
 * run() I[oCh邱.
 *
 * GUI Xbh̏ꍇ InitInstance() ŉʂ̏sȂ΂Ȃ
 * . run() ̓I[oChȂ悢. ȊÕ\bh͕Kvɉ
 * I[oCh. ȂI[oCh̍ۂ CWinThread ̑Ή郁\bh
 * ĂяoKv. ڍׂ TJMFCGUIThread QƂ̂.
 *
 * ThreadJack ̎dlƂăXbh͕KTXyhԂō쐬 start() 
 * ĂяoŎsJnƂȂ邽
 *       dwCreateFlags = CREATE_SUSPENDED
 * ͕K{Ƃwsł.
 *
 * @see TJMFCGUIThread
 */
class TJMFCThread : public TJThread {

private:
	static TJMFCThread* primary;

protected:
	/*
	 * CWinThread ̃TuNXւ̃|C^.
	 */
	TJWinThread* m_pWinThread;

public:
	/**
	 * ftHgX^bNTCY
	 */
	static const unsigned DEFSTACKSIZE;

public:
	/**
	 * RXgN^.
	 *
	 * @param stacksize X^bNTCY
	 * @param lpsec     NT ł݈̂ӖZLeB
	 */
	TJMFCThread(unsigned stacksize = DEFSTACKSIZE,
			LPSECURITY_ATTRIBUTES lpsec = 0);
	/**
	 * RXgN^.
	 *
	 * @param name      Xbh
	 * @param stacksize X^bNTCY
	 * @param lpsec     NT ł݈̂ӖZLeB
	 */
	TJMFCThread(const char* name, unsigned stacksize = DEFSTACKSIZE,
			LPSECURITY_ATTRIBUTES lpsec = 0);
	/**
	 * RXgN^.
	 *
	 * @param target    XbhGg
	 * @param stacksize X^bNTCY
	 * @param lpsec     NT ł݈̂ӖZLeB
	 */
	TJMFCThread(TJRunnable* target, unsigned stacksize = DEFSTACKSIZE,
			LPSECURITY_ATTRIBUTES lpsec = 0);
	/**
	 * RXgN^.
	 *
	 * @param target    XbhGg
	 * @param name      Xbh
	 * @param stacksize X^bNTCY
	 * @param lpsec     NT ł݈̂ӖZLeB
	 */
	TJMFCThread(TJRunnable* target, const char* name,
			unsigned stacksize = DEFSTACKSIZE,
			LPSECURITY_ATTRIBUTES lpsec = 0);

	/**
	 * main XbhIuWFNg̃|C^擾.
	 *
	 * TJMFCThread ̃TuNXƂč쐬ꂽXbh̒ł
	 *         TJThread::currentThread()
	 * ɂJgXbh̃|C^擾ł邪, AvP[V
	 * GgsXbh TJMFCThread ̃TuNXł͂Ȃ.
	 * ̃\bh AppWizard ɂč쐬ꂽ CWinApp ̃TuNX
	 * ̏ TJMFCThread IuWFNg̃|C^擾邽
	 * Ɏg.
	 *
	 *   class CXxxApp : public CWinApp {
	 *         EEEE
	 *       virtual BOOL InitInstance() {
	 *           TJMFCThread* primary = TJMFCThread::primaryThread();
	 *             EEEE
	 *           return TRUE;
	 *       }
	 *   };
	 *
	 * ̃\bhĂяo͕K{ł͂Ȃ. ̃\bhĂяoȂ
	 *  main Xbh TJMFCThread ł͂ȂƂ CWinThread 
	 * @\͎Ă.
	 *
	 * x  ̃\bh̍ŏ̌Ăяo main XbhsȂ
	 *       ȂȂ. (sɃ`FbN)
	 *       Ăяo\bh CXxxApp::InitInstance() Kł.
	 *       Qڈȍ~͔Cӂ̃Xbhs\ł.
	 */
	static TJMFCThread* primaryThread(LPSECURITY_ATTRIBUTES lpsec = 0);

protected:
	/**
	 * fXgN^
	 */
	virtual ~TJMFCThread();

protected:
	/*
	 * VXeˑ̃Xbh쐬.
	 */
	virtual int create(void (*entrypoint)(void*), void* arg,
			unsigned stacksize, void* info, ID* ptid);

public:
	/**
	 * EBhE GUI XbhǂԂ.
	 */
	virtual bool isGUIThread() { return false; }

	/**
	 * Xbh̖{.
	 *
	 * ̃\bh͋ł邱Ƃɒ.
	 * [JXbhł̓I[oChׂł, EBhE
	 * Xbh TJMFCGUIThread g.
	 */
	virtual void run() { }

	/**
	 * bZ[W[vɓȌ.
	 *
	 * @return FALSE: bZ[W[vɓ邱ƂȂ ExitInstance() 
	 *                săXbhI.
	 *         TRUE:  bZ[W[vɓ.
	 */
	virtual BOOL InitInstance();

	/**
	 * bZ[W[vȈ.
	 */
	virtual int  ExitInstance();

	/**
	 * Windows bZ[W̕ϊEfBXpb`̑O.
	 *
	 * @param pMsg Windows bZ[W\̂̃|C^
	 * @return TRUEԂƃbZ[WƔfĕϊ
	 *         уfBXpb`ɂ͐i܂Ȃ.
	 */
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	/**
	 * ACh̏.
	 *
	 * @param lCount AChԂɂȂĂ̒ʎZĂяo
	 * @return TRUEԂƃbZ[WȂΈ OnIdle() 
	 *         Ăяo.
	 */
	virtual BOOL OnIdle(LONG lCount);

	/**
	 * ACh̏sׂǂ̃qg.
	 *
	 * @param pMsg OɏꂽbZ[W
	 * @return FALSE Ȃ OnIdle() sׂł͂Ȃ
	 */
	virtual BOOL IsIdleMessage(MSG* pMsg);

	/**
	 * bZ[WtB^[.
	 */
	virtual BOOL ProcessMessageFilter(int code, LPMSG lpMsg);

	/**
	 * ̗O̕ߊl.
	 */
	virtual LRESULT ProcessWndProcException(CException* e,
			const MSG* pMsg);
};


#endif	/* !defined(TJMFCThread_h) */
