/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJMonitor.cc,v 1.3 1999/04/12 11:08:36 hiranabe Exp $
 */
#include "TJMonitor.h"

/**
 * bNp̃IuWFNg TJSyncObject ͍ċAIȃbNl\ł.
 * bNxP̏ꍇ LOCK [h UNLOCK [h͂܂t̑
 * ƌ邪ċAIȃbNԂł͔ȈႢ.
 *
 * LOCK[h
 *   RXgN^łPx̃bNl
 *   fXgN^łPxbN
 *
 * UNLOCK[h
 *   RXgN^ŃbNxLbNSɉ
 *   fXgN^Ō̃xɕ
 */

/**
 * TJMonitor IuWFNg쐬.
 */
TJMonitor::TJMonitor(const TJSyncObject* obj, Mode mode /*=LOCK*/)
		: object(const_cast<TJSyncObject*>(obj)) {
	lockcount = -1;
	if (mode == LOCK)
		object->lock();
	else
		lockcount = object->unlockTemporarily();
}

/**
 * TJMonitor IuWFNg.
 */
TJMonitor::~TJMonitor() {
	if (lockcount < 0)
		object->unlock();
	else
		object->restoreLock(lockcount);
}
