/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJMonitorTester.h,v 1.11 1999/07/31 01:45:23 tokui Exp $
 */
#if !defined(TJMonitorTester_h)
#define TJMonitorTester_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJThread_h
#include "TJThread.h"
#endif
#ifndef tjiostream_h
#include "tjiostream.h"
#endif

class TJMonitor;
class TJSyncObject;
//class ostream;

/**
 * TJSyncObject(TJMonitor) ̓Ԃ邽߂̃NX ---- eXgp.
 *
 * ̃NX̓eXgpłAvP[VvO̒Ŏg邱
 * ͑z肵ĂȂ.
 * Ώۂ TJSyncObject(TJMonitor) ̂uԂ̃XibvVbgQƂ
 * 邾ł, ꂪǂ̓eXgvOɈˑ.
 * ƂΕ̃XbhΏۂ̃IuWFNgpɂɃANZXĂ
 * ł, ̃NX̕ԂʂTdɌȂ΂ȂȂ.
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJMonitorTester {

private:
	const TJSyncObject* synobj;

public:
	/**
	 * TJSyncObject ̃|C^^ TJMonitorTester IuWFNg쐬.
	 *
	 * @param synobj Ώۂ TJSyncObject ̃|C^
	 */
	TJMonitorTester(const TJSyncObject* synobj);

	/**
	 * TJMonitor ̃|C^^ TJMonitorTester IuWFNg쐬.
	 *
	 * @param mon Ώۂ TJMonitor ̃|C^
	 */
	TJMonitorTester(const TJMonitor* mon);

	/**
	 * TJMonitorTester IuWFNg.
	 */
	virtual ~TJMonitorTester();

	/**
	 * bNlĂXbh̎ʎqԂ.
	 *
	 * @return Xbh̎ʎq
	 */
	TJThread::ID getMonitorOwner() const;

	/**
	 * bNvĂXbh邩ǂ𒲂ׂ.
	 *
	 * @return bNvĂXbh
	 */
	int getMonitorWant() const;

	/**
	 * bÑlXgxԂ.
	 *
	 * TJSyncObject ͓XbhȂ΍ċAIɃbNl\.
	 * @return bÑlXgx
	 */
	int getMonitorNest() const;

	/**
	 * Ώۂ TJSyncObject ő҂ĂXbh邩ǂ𒲂ׂ.
	 *
	 * @return ҂ĂXbh
	 */
	int getSignalWant() const;

	/**
	 * TJMonitorTester IuWFNg̓o͂.
	 *
	 * @param o o̓Xg[
	 * @return  o̓Xg[̎Q
	 */
	ostream& print(ostream& o) const;
};


/**
 * TJMonitorTester IuWFNg̓o͂.
 *
 * @param o o̓Xg[
 * @param tester  o͑Ώۂ TJMonitorTester
 * @return  o̓Xg[̎Q
 */
inline ostream& operator<<(ostream& o, const TJMonitorTester& tester) {
	return tester.print(o);
}


#endif	/* !defined(TJMonitorTester_h) */
