/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJRunnable.h,v 1.11 1999/07/28 06:02:17 hiranabe Exp $
 */
#if !defined(TJRunnable_h)
#define TJRunnable_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

/**
 * XbhɂsvÕC^tF[XK肷钊ۃNX.
 *
 * TJRunnable ́CXbhɂsvŐʂ̃vgR
 * K肷邽߂ɂCrun() \bh̃vO{̂łDXbh
 * run() s̎C̃Xbh alive łƂD
 *
 * TJRunnable IuWFNg TJThread IuWFNgɓnꍇC
 * TJThread  start() \bhĂяoƂɂ, run()
 * ĂяoD
 *
 * \begin{verbatim}
 *
 *	class MyRunnable : public TJRunnable {
 *		  EEEE
 *	    public:
 *		  EEEE
 *		void run() {
 *			  EEEE  // implement TJRunnable::run()
 *		}
 *	};
 *
 *	MyRunnable* runnable = new MyRunnable;
 *	TJThread* thread = new TJThread(runnable, "myname");
 *	thread->start(); // MyRunnalbe::run()  thread ɂĎs
 *  .........
 *  thread->join();  // KvłΏI҂킹
 *  
 * \end{verbatim}
 *
 * run() ̏ÍC̃Xbh TJRunnable ^[QbgƂ TJThread
 *  join() \bhő҂킹邱ƂłD
 * run() ̂܂ܔ join() Ŏ󂯎
 * IR[h 0 łDIɏIR[h join() ɓnɂ́C
 * run() ̏I TJThread::exit(int) Ăяo΂悢D
 *
 * TJRunnable gp, TJThread 𒼐ڃTuNXĂXbh{
 * \ł(TJThread Q)DTJRunnable gp闘_́C1
 * TJRunnable IuWFNg𕡐 TJThread IuWFNgŋpł
 * _łD
 *
 * Java ̎dlƈႢCTJThread g TJRunnable pȂD
 * ́CTJThread RXgN^ TJThread nƂ~Xh
 * ӖD
 *
 * TJThread  TJRunnable ̎gɂẮCTJThread QƂ邱ƁD
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 * @see TJThread
 */
class TJRunnable {
public:
	/**
	 * Xbh{̂̃C^tF[X.
	 *
	 * XbhɂĎsvÕGg|Cg
	 * ƂȂD
	 *
	 * @see TJThread#run()
	 * @see TJThread#start()
	 */
	virtual void run() = 0;
};


#endif	/* !defined(TJRunnable_h) */
