/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSafeObserver.h,v 1.6 1999/07/28 06:02:23 hiranabe Exp $
 */
#if !defined(TJSafeObserver_h)
#define TJSafeObserver_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJObserver_h
#include "TJObserver.h"
#endif
#ifndef TJSyncObject_h
#include "TJSyncObject.h"
#endif

class TJSafeObservable;

/**
 * XbhZ[t Observer.
 *
 * Observable  update Ăяoɑ΂āC
 * IɃbN擾DTJSafeObservable ɏڍׂȃRgD
 *
 * @author hiranabe
 * @date 1999,3/30
 * @see TJSafeObservable
 * @see TJObserver
 */
class TJSafeObserver: public TJObserver, public virtual TJSyncObject {
public:
    /**
     * Observable IuWFNgωƂɂ̃\bhĂяo.
     * ۂɂ́CsafeUpdate oRŌĂяo邽߁CIɃbN
     * 擾Ẵ\bhɓD
     *
     * ̃\bh override āCAvP[V̓Lq.
     * @param o  Observable IuWFNg
     * @param arg Observable  notifyObservers \bhɓnD
     *            AvP[VŎRɎgpD
     */
    virtual void update(TJObservable& o, void* arg) = 0;

    /**
     * XbhZ[tȂ̂ǂ̌.
     *
     * ̃NX́Ctrue ԂD
     *
     * @return true XbhZ[t
     */
    virtual bool isSafe() const;

    /**
     * fXgN^.
     */
    virtual ~TJSafeObserver();

protected:
    friend TJSafeObservable;
    /**
     * update ̃XbhZ[to[W.
     *
     * ̃\bh override ȂƁDSafeObservable ́CĂяoC
     * ̃\bh́CbN擾 update \bhĂяoD
     * 
     * @param o  Observable IuWFNg
     * @param arg Observable  notifyObservers \bhɓnD
     *            AvP[VŎRɎgpD
     */
    virtual void safeUpdate(TJObservable& o, void* arg);
};

#endif	/* !defined(TJSafeObserver_h) */
