/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSync.h,v 1.9 1999/07/28 06:02:29 hiranabe Exp $
 */
#if !defined(TJSync_h)
#define TJSync_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

class TJMutex;

/**
 * v~eBu.
 *
 * ̃NX͂b̓v~eBu(VXeˑ[`)
 * JvZ邱ƂړIł肩Ȃ჌xł.
 * ڎgȂƂ𐄏邪֎~͂Ȃ.
 *
 * ̃NX̓IuWFNg쐬鎞ɂ͔rpIuWFNg
 * KvƂ.
 * PȓKvȂZ}tHNX(TJSemaphore)pӂ
 * ̂łgp邱Ƃ𐄏.
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJSync {

private:
	void* sync;
	void* mutex;

public:
	/**
	 * TJSync IuWFNg쐬.
	 *
	 * @param m ̃IuWFNgƑ΂Ȃ TJMutex IuWFNg
	 */
	TJSync(const TJMutex* m);

	/**
	 * TJSync IuWFNg.
	 */
	~TJSync();

	/**
	 * ʂ̃XbhN܂ŃubN.
	 */
	void wait();

	/**
	 * ^CAEgw肵ĕʂ̃XbhN܂ŃubN.
	 *
	 * @param milliseconds ~b
	 * @return true: Nꂽ, false: ^CAEg
	 */
	bool timedwait(long milliseconds);

	/**
	 * ̃IuWFNgő҂ĂXbhN.
	 */
	void signal();

	/**
	 * ̃IuWFNgő҂Ă邷ׂẴXbhN.
	 */
	void broadcast();
};


#endif	/* !defined(TJSync_h) */
