/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJTransaction.cc,v 1.3 1999/04/12 11:08:59 hiranabe Exp $
 */
#include "TJTransaction.h"

/**
 * QƂ܂͍XV[hŃbNlD
 * TJRWLock̋@\̂^CAEgw trylock (NONBLOCK) 
 * @\͏OĂ邱ƂɒӁD
 * @param rwlock TJRWLockIuWFNg̃|C^
 * @param mode   TJRWLock::SHARED:     Qƃ[h
 *               TJRWLock::EXCLUSIVE:  XV[h
 */
TJTransaction::TJTransaction(TJRWLock* lock, TJRWLock::LockMode mode)
		: rwlock(lock) {
	(void)rwlock->beginTransaction(mode, TJRWLock::INFINITE);
}

/**
 * bND
 */
TJTransaction::~TJTransaction() {
	rwlock->endTransaction();
}
