/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJUtility.h,v 1.8 1999/07/28 06:02:49 hiranabe Exp $
 */
#if !defined(TJUtility_h)
#define TJUtility_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#include <string>
#ifndef tjstdnamespace_h
#include "tjstdnamespace.h"
#endif

/**
 * Pȃ[eBeB\bh񋟂NX.
 *
 * IuWFNgƂ͖֌WɎg֗Ȏ葱Ȃǂ̃NXɏW߂D
 */
class TJUtility {

public:
	/**
	 * ̍ŉʃoCg16iɕϊ.
	 *
	 * yzbyte=0xe5 Ȃ "e5" ԂD
	 *
	 * @param byte oCg
	 * @return 
	 */
	static string toHexString(int byte);

	/**
	 * ^ꂽf[^16iɕϊ.
	 *
	 * @param data f[^̐擪AhX
	 * @param count f[^̃oCg
	 * @param byteperline 1s̕
	 * @return 
	 */
	static string toHexString(const char* data, int count,
                              int byteperline = 16);

	/**
	 * ^ꂽf[^16i_v`ɕϊ.
	 *
	 * @param offset \pItZbgAhX
	 * @param data f[^̐擪AhX
	 * @param count f[^̃oCg
	 * @param byteperline 1s̕
	 * @return 
	 */
	static string toHexDumpFormat(unsigned offset, const char* data,
                                  int count, int byteperline = 16);

	/**
	 * ̍ŉʃoCg2iɕϊ.
	 *
	 * yzbyte=0xe5 Ȃ "11100101" ԂD
	 * @param byte oCg
	 * @return 
	 */
	static string toBinString(int byte);

	/**
	 * ^ꂽf[^2iɕϊ.
	 *
	 * @param data f[^̐擪AhX
	 * @param count f[^̃oCg
	 * @param byteperline 1s̕
	 * @return 
	 */
	static string toBinString(const char* data, int count,
                              int byteperline = 8);

	/**
	 * sZp[^Ԃ.
	 *
	 * sR[h UNIX ł "\n" ł MS-DOS ł "\r\n"
	 * łD܂VXeˑł邽߂̃\bhɂ
	 * ڐA߂KvD
	 *
	 * @return s
	 */
	static string separator();

	/**
	 * W̃t@CVXeŗL̃t@Cɕϊ.
	 * yӁzThreadJack W̃t@C̃pXZp[^
	 * ̓XbVƂD
	 *
	 * @return pX("/", "\"Ȃ)
	 */
	static string sysdepFilename(const string& filename);

private:
	static string toPrintable(const char* data, int count);
};


#endif	/* !defined(TJUtility_h) */
