/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved                         

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJWThread.cc,v 1.1 1999/05/21 07:20:43 tokui Exp $
 */
/**
 * Windows ł̃v~eBu[`
 *
 *         ------------------------------
 *         ̃\[Xt@C
 *             R\[AvP[V
 *             MFC [JXbh
 *             MFC GUI Xbh
 *         ɑΉĂ.
 *         ------------------------------
 *
 * Windows ł̓XbhƂăVXeňӂ̃XbhIDƃvZX
 * ̃XbhnĥQޑ݂.
 *
 * (a) _beginthreadex() ܂ CreateThread() ͗ԂĂ.
 *
 * (b) ̊֐ł̓nhKvɂȂ.
 *         static int TJThreadStart(void* tid)
 *         int TJThreadSetPriority(void* tid, int npri)
 *         int TJThreadGetPriority(void* tid, int* pnpri)
 *
 * (c) ̊֐ł͂ǂʎqƂ邩߂Ȃ΂ȂȂ.
 *         void* TJThreadSelf()
 *
 * Xbh̃nh pthread_t ̂悤ɃXbh̎ʏł葀
 * ɂgƂł͂Ȃ悤ł. (TJThreadSelf() QƂ̂.)
 *
 * L(b)̊֐̓XbhƂɒʏPxĂ΂Ȃ.
 * ɑ΂ TJThreadSelf() ͕pɂɌĂяo邽 TJThreadSelf() 
 * D悷.
 *
 * ďʑwƂ̃C^[tF[XƂănhł͂ȂXbhID
 * gƂɒӂ邱. ܂ void* tid ̓XbhIDł.
 * Xbhɂ̓nhKvȂIDƃnhƂ̑Ή̃t@C
 * ŊǗ.
 * ̏̓XbhƂł͂ȂO[oɔr䂵Ȃ΂ȂȂ.
 */

/*
 * }N TJ_MFC  MFC gǂӖĂ.
 * R\[AvP[V AfxXXX() gƃN̖肪N邽
 * ̃}NŏRpCs.
 *
 * AppWizard ̓R\[AvP[VIԂ _CONSOLE tĂ
 * , ƓKȏ邩Ȃ. Ƃ _AFXDLL Ȃ.
 */
#if !defined(TJ_NOMFC) && !defined(TJ_MFC) && !defined(_CONSOLE)
#	define TJ_MFC
#endif

#if defined(TJ_MFC)
/*
 * ----------------------------------------------------------
 * C++ RpCKvȂ߃\[Xt@C *.c ł͂Ȃ.
 * ----------------------------------------------------------
 */
#	include <afxwin.h>
#	include <afxext.h>
#else
#	include <windows.h>
#endif
#include <process.h>
#include <assert.h>
#include <errno.h>

#include "TJPrimitive.h"


/**
 * Xbh̃^Cv
 */
typedef enum type {
	Undefined,
	ConsoleApplication,
	MFC_WorkerThread,
	MFC_GUIThread
} type_t;

/**
 * XbhʎqƃXbhnh̑ΉǗ郊Xg̗vf.
 */
typedef struct thinfo {
	struct thinfo* next;
	struct thinfo* prev;
	DWORD  tid;           /* Xbhʎq */
	HANDLE handle;        /* Xbhnh */
} thinfo_t;

static type_t threadtype = Undefined;
static thinfo_t thlist = { 0, 0, 0, 0 };
static void* thlock = 0;

#define MUTEXLOCK(tl, e) \
	if (tl == 0) { e = TJMutexCreate(&tl); if (e) return e; } \
	e = TJMutexLock(tl); if (e) return e
#define MUTEXUNLOCK(tl, e) \
	e = TJMutexUnlock(tl); if (e) return e


/**
 * XbhʎqXbhnh𓾂.
 */
static int getHandle(HANDLE* ph, DWORD id) {
	thinfo_t* p;
	int error;

	MUTEXLOCK(thlock, error);
	for (p = thlist.next; p != 0; p = p->next)
		if (p->tid == id)
			break;
	*ph = (p != 0)? p->handle : 0;
	MUTEXUNLOCK(thlock, error);
	return 0;
}

/**
 * XbhʎqƃXbhnh̑ΉXgɒǉ.
 */
static int addInfo(DWORD id, HANDLE h) {
	thinfo_t* p;
	int error;

	if ((p = (thinfo_t*)malloc(sizeof(thinfo_t))) == 0)
		return ENOMEM;

	MUTEXLOCK(thlock, error);

	p->tid = id;
	p->handle = h;
	p->next = thlist.next;
	thlist.next = p;
	if (p->next != 0)
		p->next->prev = p;
	p->prev = &thlist;

	MUTEXUNLOCK(thlock, error);
	return 0;
}

/**
 * XbhʎqƃXbhnh̑ΉXg폜.
 */
static int removeInfo(DWORD id) {
	thinfo_t* p;
	int error;

	MUTEXLOCK(thlock, error);
	for (p = thlist.next; p != 0; p = p->next)
		if (p->tid == id)
			break;
	if (p != 0) {
		if (p->prev != 0)
			p->prev->next = p->next;
		if (p->next != 0)
			p->next->prev = p->prev;
		free((void*)p);
	}
	MUTEXUNLOCK(thlock, error);
	return 0;
}

/**
 * n.
 */
static void cleanInfo() {
	if (thlock == 0)
		return;
	TJMutexDelete(thlock);
	thlock = 0;
}


/*****************************************************************************
 *                 Xbh֘Ãv~eBu
 *****************************************************************************/

/**
 * Xbh𐶐.
 *
 * ԂTXyhƂăXbh𐶐.
 *
 * Xbh̃Gg|Cǧ^錾
 *     void threadbody(void* arg)
 * ł邱.
 */
static int TJThreadCreate(const char* name, unsigned stacksize,
			  void (*entrypoint)(void*), void* arg, void** ptid) {

	HANDLE hThread;
	DWORD tid;

	hThread = (HANDLE)_beginthreadex(NULL, 0,
			(UINT (_stdcall*)(void*))entrypoint, arg,
			CREATE_SUSPENDED, (UINT*)&tid);
	if (hThread == 0)
		return errno;

	*ptid = (void*)tid;
	/*
	 * ̊֐Ă΂ꂽR\[AvP[Vł.
	 * ̃P[Xł TJThread::create() ̓I[oChꂸ
	 * ::TJThreadMake()oRĂ̊֐ɗ.
	 */
	threadtype = ConsoleApplication;
	return addInfo(tid, hThread);
}

/**
 * Xbh̐ݒ.
 */
int TJThreadSetInfo(void* thread, void** array) {
	DWORD tid = (DWORD)thread;
	HANDLE hThread = (HANDLE)array[0];
	/*
	 * ̊֐Ă΂ꂽ MFC  CWinThread gĂ.
	 * ̃P[Xł TJThread::create()  TJMFCThread::create()
	 * ɃI[oCh ::TJThreadMake() ł͂Ȃ
	 * CWinThread::CreateThread() ɂăXbh쐬ꂽ
	 * ̊֐gďZbg.
	 */
	threadtype = (array[1] == 0)? MFC_WorkerThread : MFC_GUIThread;
	return addInfo(tid, hThread);
}

/**
 * JgXbhID
 *
 * w̃XbhI@\͗pӂȂD
 *
 * mfc/src/thrdcore.cpp ̊֘A镔Ă.
 * Xbh쐬̃R[hpX͎̂Ƃ.
 *
 *  CWinThread::CreateThread(...)
 *      _beginthreadex(... &_AfxThreadEntry, ...)
 *
 * CWinThread ̃Xbh{͎̂̂悤ɂȂĂ.
 *
 *  _AfxThreadEntry(...)
 *        EEE
 *      // first -- check for simple worker thread
 *      DWORD nResult = 0;
 *      if (pThread->m_pfnThreadProc != NULL) {
 *          nResult = (*pThread->m_pfnThreadProc)(pThread->m_pThreadParams);
 *      } else if (!pThread->InitInstance()) { // else -- check for thread
 *                                             // with message loop
 *          nResult = pThread->ExitInstance();
 *      } else {
 *          // will stop after PostQuitMessage called
 *          nResult = pThread->Run();
 *      }
 *      // cleanup and shutdown the thread
 *      threadWnd.Detach();
 *      AfxEndThread(nResult);
 *
 * CWinThread  m_pfnThreadProc ^ƃ[JXbhƂ݂Ȃ悤
 * ThreadJack ł̓Xbh{̂ɓ̐\肷邽 GUI Xbh
 * ǂɊւ炸 m_pfnThreadProc = TJThreadbody ƂăXbh쐬
 * . TJThread.cc QƂ̂.
 */
static void TJThreadExit(int code) {
	(void)removeInfo((DWORD)TJThreadSelf());
	switch (threadtype) {
	case ConsoleApplication:
		_endthreadex(code);
		/* not reached */
#if defined(TJ_MFC)
	case MFC_WorkerThread:
		/*
		 * }jAɂ AfxEndThread() ĂяoXbh{
		 * 畜AƏĂ.
		 */
		AfxEndThread(code);
		/* not reached */
	case MFC_GUIThread:
		/*
		 * ??????????????????? v ???????????????????????????
		 * ̃P[X͖ł.
		 * }jAɂ GUIXbh̏ꍇ͏IXbh
		 * ::PostQuitMessage() Ăяo悤ɏĂ邪, 
		 * @ŏÎ̓bZ[W[v܂Ŗ߂邽߂ł.
		 * run() IĂɗĂȂ͂Ȃ
		 *       TJThread::exit()
		 * ̖IȌĂяoɂĂɗȂ exit() A
		 * Ă܂.
		 * ɂ͗O(܂longjmp)gȂ.
		 * GUI Xbh̃R[h̓Cxĝ݂Ƃ
		 * łvO}̈ӎƂĂ̓Cxg[vɐ
		 * Ă邱Ƃ͏\mĂ. Ă̏ꍇ
		 * exit()gȂƂƂ͏dȐł͂Ȃ
		 * Ȃ.
		 *  GUIXbh̏ꍇ̂ exit() ֎~Ȃ
		 * TJThread.cc  TJThreadbody() ŌĂяo exit() 
		 * ł悤ɏCO exit() Ă΂ꂽ abort()
		 * 悤ɂ΂悢.
		 * ??????????????????????????????????????????????????????
		 */
		::PostQuitMessage(code);
		break;
#endif
	default:
		assert(false);	/* Oops! */
		break;
	}
}

/**
 * XbhsJnD
 */
static int TJThreadStart(void* tid) {
	HANDLE hThread;
	int error = getHandle(&hThread, (DWORD)tid);
	if (error)
		return error;
	if (ResumeThread(hThread) == 0xffffffff)
		return GetLastError();
	return 0;
}

/**
 * JgXbĥhcԂD
 *
 * JgXbh̃nhԂ
 *     WINBASEAPI HANDLE WINAPI GetCurrentThread(VOID);
 * ͂Ȃ 0xfffffffe ԂߎʏƂĂ͎gȂ.
 */
void* TJThreadSelf() {
	DWORD tid = GetCurrentThreadId();
	return (void*)tid;
}

/**
 * KiꂽDxVXeŗL̗DxɕϊD
 */
static int specificPriority(int npri) {
/*???????????????????????????? v ????????????????????????????*/
	return npri;
}

/**
 * VXeŗL̗DxKiꂽDxɕϊD
 */
static int normalizedPriority(int spri) {
/*???????????????????????????? v ????????????????????????????*/
	return spri;
}

/**
 * Xbh̗Dxݒ肷D
 */
int TJThreadSetPriority(void* tid, int npri) {
#if 0
	HANDLE hThread;
	int spri;
	int error = getHandle(&hThread, (DWORD)tid);
	if (error)
		return error;
	spri = specificPriority(npri);
	if (SetThreadPriority(hThread, spri) == FALSE)
		return GetLastError();
#endif
	return 0;
}

/**
 * Xbh̗Dx擾D
 */
int TJThreadGetPriority(void* tid, int* pnpri) {
#if 0
	HANDLE hThread;
	int spri;
	int error = getHandle(&hThread, (DWORD)tid);
	if (error)
		return error;
	spri = GetThreadPriority(hThread);
	if (spri == THREAD_PRIORITY_ERROR_RETURN)
		return GetLastError();
	*pnpri = normalizedPriority(spri);
	return 0;
#endif
	*pnpri = 5;
	return 0;
}

/**
 * JgXbh̐ꎞIɃVXeɕԂD
 *
 * JgXbh̓fBԂɂƂǂ܂邱ƂɒӁD
 */
void TJThreadYield() {
	Sleep(0);
}


/* ------------------------------------------------------------------------ */

/**
 * ThreadJack I.
 */
void TJPrimCleanup() {
	cleanInfo();
}

/**
 * Xbh֘Ȁ
 *
 * TJThread::init()Ăяo邪C̃^C~O͕K main Xbh
 * Ă͂D
 */
int TJThreadInit() {
	return 0;
}

/**
 * Xbh𐶐D
 *
 * ̊֐̓Xbh𐶐邪sJnȂƂɒӁD
 * sJn TJThreadStart() ďołD
 *
 * Xbh̃Gg|Cǧ^錾
 *     void threadbody(void* arg)
 * ł邱ƁD
 */
int TJThreadMake(const char* name, unsigned stacksize,
		void (*entrypoint)(void*), void* arg, void** ptid) {
	return TJThreadCreate(name, stacksize, entrypoint, arg, ptid);
}

/**
 * JgXbhID
 */
void TJThreadTerminate(int code) {
	TJThreadExit(code);
}

/**
 * JgXbhw莞ԋx~D
 */
int TJThreadSleep(int milliseconds) {
	Sleep((DWORD)milliseconds);
	return 0;
}

/**
 * sJn҂킹D
 *
 * Windows ł̓TXyhԂ̃Xbh쐬ł.
 */
int TJThreadWaitforStart(void* tid) {
	return 0;
}

/**
 * XbhsJnD
 */
int TJThreadStartup(void* tid) {
	return TJThreadStart(tid);
}
