/**
 * ********************************************************
 * ------- EBhEȂXbh̃Tv ---------
 * EBhEȂXbh̏ꍇ TJMFCThread g.
 * ********************************************************
 *
 * ̃Xbh request() ҂ wait() Ă.
 * CKicker  request() Ăяo notify() ꂽ
 *       main Xbhɂ̓XbhbZ[W܂̓EBhEbZ[W
 *       CKicker ɂ̓XbhbZ[W
 * 𑗐MčĂ wait() .
 */

#include "Worker.h"
#include "TJMFCGUIThread.h"
#include "Board.h"


CWorker::CWorker(TJMFCGUIThread* kicker) : TJMFCThread(), TJSyncObject() {
	reqID = NONE;
	msgbuf[0] = '\0';
	this->kicker = kicker;

	/*
	 *******************************************************
	 * main Xbh TJMFCGUIThread ƂĈ|C^
	 * ̕@Ŏ擾ł.
	 *******************************************************
	 */
	primary = TJMFCGUIThread::primaryThread();

	/*
	 *****************************
	 * ̃CEBhE擾.
	 *****************************
	 */
	pWnd = primary->GetMainWnd();
}

CWorker::~CWorker() {
}

void CWorker::request(RequestID reqID, const char* msg, int msglen) {

	synchronized (this) {
		this->reqID = reqID;
		if (msg == 0) {
			msgbuf[0] = '\0';
		} else {
			if (msglen >= sizeof(msgbuf))
				msglen = sizeof(msgbuf) - 1;
			::strncpy(msgbuf, msg, msglen);
			msgbuf[msglen] = '\0';
		}
		this->notify();
	}
}

/**
 * POST v݂ɃXbhbZ[WEBhE
 * bZ[W main XbhɑM CKicker Xbhɂ
 * Ԃ.
 */
void CWorker::post(int serialno) {
	/*
	 ******************************************************************
	 * Windows bZ[WXbhɑMƃEBhEɑM
	 ******************************************************************
	 */
	if ((serialno & 1) == 1)
		primary->PostThreadMessage(IDWORKERMESSAGE, 0, (LONG)msgbuf);
	else
		pWnd->PostMessage(IDWORKERMESSAGE, 0, (LONG)msgbuf);

	::wsprintf(reply, "Worker: OK NO.%d", serialno);
	kicker->PostThreadMessage(IDWORKERMESSAGE, 0, (LONG)reply);
}

/**
 * XbhGg.
 */
void CWorker::run() {

	synchronized (this) {
		for (int serialno = 1; ; ) {
			this->wait();
			if (reqID == QUIT)
				return;
			if (reqID == POST)
				post(serialno++);
		}
	}
}
