/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJObserver.h,v 1.7 1999/07/28 06:02:11 hiranabe Exp $
 */
#if !defined(TJObserver_h)
#define TJObserver_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

class TJObservable;

/**
 * IuU[o[p^[x Observer NX(Observer/Subscriber ).
 *
 * Observer  Observable ̕ω̒ʒm󂯂NXD
 * Model-View  View IuWFNg̃NXpD
 *
 * [bNj]
 *
 * ̃NX́C}`XbhɊւ郍bNSӎȂD
 * Kvł TJSafeObserver D
 *
 * @author hiranabe
 * @date 1999,3/30
 * @see TJObservable
 * @see TJSafeObserver
 */
class TJObserver {
public:
    /**
     * Observable IuWFNgωƂɂ̃\bhĂяo.
     *
     * AvP[V́CObservable IuWFNg notifyObservers \bh
     * тăIuWFNg̏ԕω Observer ɓ`D
     *
     * @param o  Observable IuWFNg
     * @param arg Observable  notifyObservers \bhɓnD
     *            AvP[VŎRɎgpD
     */
     virtual void update(TJObservable& o, void* arg) = 0;

    /**
     * XbhZ[tȂ̂ǂ̌.
     *
     * ̃NX̂̂ł falseD
     *
     * @return true XbhZ[t
     */
    virtual bool isSafe() const;

    /**
     * fXgN^.
     */
    virtual ~TJObserver();
};

#endif	/* !defined(TJObserver_h) */
