/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSafeEventListener.h,v 1.7 1999/07/28 06:02:18 hiranabe Exp $
 */
#if !defined(TJSafeEventListener_h)
#define TJSafeEventListener_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJEventListener_h
#include "TJEventListener.h"
#endif
#ifndef TJMonitor_h
#include "TJMonitor.h"
#endif


/**
 * XbhZ[tȃCxgXi.
 *
 * TJSafeEventSource  TJSafeEventListener ɂCxg`B@\
 * ̓}`Xbhɂ闘pz肵̈S߂ĂD
 *
 * gṕCTJSafeEventSource D
 *
 * [bNj]
 *
 * dvȒӎƂ eventHappened() ͂̃IuWFNg̃bNl
 * ĂяoꕜAɃbND
 *  eventHappened() ̎s̓}`XbhłIuWFNg
 * ͈SłD
 *
 * @author tokui, hiranabe
 * @date 1998,7/31
 * @date 1999,4/1
 * @see TJSafeEventSource
 * @see TJEventListener
 */
template<class EventType> class TJSafeEventListener:
    public TJEventListener<EventType>,
    virtual public TJSyncObject {
public:
    /*
     * fXgN^.
     */
    virtual ~TJSafeEventListener() { }

    /**
     * XbhZ[tȂ̂ǂ̌.
     *
     * ̃NX́Ctrue ԂD
     *
     * @return true XbhZ[t
     */
    virtual bool isSafe() { return true; }

    /**
     * CxgÑR[obN.
     *
     * @param ev CxgIuWFNg
     */
    virtual void safeEventHappened(const EventType& ev) {
        TJMonitor synchro__(this);  // this bNfXgN^ŉ
        eventHappened(ev);
    }
};


#endif	/* !defined(TJSafeEventListener_h) */
