/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSafeObserver.cc,v 1.3 1999/04/12 11:08:48 hiranabe Exp $
 */
#include "TJSafeObserver.h"
#include "TJMonitor.h"

bool TJSafeObserver::isSafe() const {
    return true;
}

void TJSafeObserver::safeUpdate(TJObservable& o, void* arg) {
    synchronized(this) {
        update(o, arg);
    }
}


TJSafeObserver::~TJSafeObserver() {
}
