/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved                         

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJWMutex.c,v 1.1 1999/05/21 07:20:41 tokui Exp $
 */
/**
 * Windows ł̃v~eBu[`
 */

#include <windows.h>
#include <errno.h>
#include "TJPrimitive.h"


/*****************************************************************************
 *                   r֘Ãv~eBu
 *****************************************************************************/

/**
 * rbN𐶐.
 */
int TJMutexCreate(void** pmutex) {
	void* mutex = malloc(sizeof(CRITICAL_SECTION));
	if (mutex == (void*)0)
		return ENOMEM;
	InitializeCriticalSection((LPCRITICAL_SECTION)mutex);
	*pmutex = mutex;
	return 0;
}

/**
 * rbN폜.
 */
void TJMutexDelete(void* mutex) {
	DeleteCriticalSection((LPCRITICAL_SECTION)mutex);
	free(mutex);
}

/**
 * rbNl.
 */
int TJMutexLock(void* mutex) {
	EnterCriticalSection((LPCRITICAL_SECTION)mutex);
	return 0;
}

/**
 * rbN.
 */
int TJMutexUnlock(void* mutex) {
	LeaveCriticalSection((LPCRITICAL_SECTION)mutex);
	return 0;
}
