/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved                         

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: tjdebug.h,v 1.7 1999/07/31 01:38:54 tokui Exp $
 */
#if !defined(tjdebug_h)
#define tjdebug_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

// VXe <assert.h> ̃CN[h́Ctjdebug.h ̌
// assert  include Ȃ悤ɂ邽
#include <assert.h>
#include <stdio.h>
#ifndef TJSystemInternal_h
#include "TJSystemInternal.h"
#endif

/**
 * DbC(Design by Contract) ɊÂăfobOxc[QD
 * (gppłCAvP[Vւ̌J͈Ӑ}Ȃ)
 * 
 * require: O
 * ensure:  
 * assert:  ^\
 *
 * @author hiranabe
 * @date 1998, 12/25
 * @see uIuWFNgwv(Dr.Meyer)
 *
 */

/**
 * ̃}ŃCThreadJack VXeŜŎgp.
 * ̗\̂悤ɈDɁCTJMonitor.h Œ`
 * synchronized lD
 *
 * ׂ NDEBUG ƂvCvZbT}NɊÂĂD
 * o׎ NDEBUG `邱ƂŏĂ܂ƂɒӂC
 * G[ɂ͎gpȂƁD
 * ܂łdl̖m̂߂̈ӖŎgD
 *
 * o׌g}NCTJSystemInternal.h ɒ`ĂD
 */
#ifndef NDEBUG
#undef assert
/**
 * O\
 */
#define require(cond) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "precondition fail '" #cond "'"), 0))
/**
 * O\
 */
#define require_(cond, msg) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "precondition fail: " msg " '"  #cond "'"), 0))

/**
 * \
 */
#define ensure(cond) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "postcondition fail '" #cond "'"), 0))
/**
 * \
 */
#define ensure_(cond, msg) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "postcondition fail : " msg "'" #cond "'"), 0))

/**
 * ^\
 */
#define assert(cond) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "assertion fail '"#cond "'"), 0))
/**
 * ^\
 */
#define assert_(cond, msg) (void)((cond) || (TJSystemInternal::inconsistentPanic(__FILE__, __LINE__, "assertion fail: " msg "'"  #cond "'"), 0))

#define mem_assert(ptr) (void)((ptr) || (TJSystemInternal::nomemPanic(__FILE__, __LINE__, ""), 0))
#define mem_assert_(ptr, msg) (void)((ptr) || (TJSystemInternal::nomemPanic(__FILE__, __LINE__, msg ": "), 0))

#define trace(msg) (void)(printf(msg),printf("\n"))
#define trace1(format, arg1) (void)(printf(format, arg1),printf("\n"))
#define trace2(format, arg1, arg2) (void)(printf(format, arg1, arg2),printf("\n"))
#define trace3(format, arg1, arg2, arg3) (void)(printf(format, arg1, arg2, arg3),printf("\n"))
#define trace4(format, arg1, arg2, arg3, arg4) (void)(printf(format, arg1, arg2, arg3, arg4),printf("\n"))
#define trace5(format, arg1, arg2, arg3, arg4, arg5) (void)(printf(format, arg1, arg2, arg3, arg4, arg5),printf("\n"))
#define debug(statement) { statement }

#else

#undef assert

#define require(cond)
#define require_(cond, msg)

#define ensure(cond)
#define ensure_(cond, msg)

#define assert(cond)
#define assert_(cond, msg)

#define mem_assert(ptr)
#define mem_assert_(ptr, msg)

#define trace(msg)
#define trace1(format, arg1)
#define trace2(format, arg1, arg2)
#define trace3(format, arg1, arg2, arg3)
#define trace4(format, arg1, arg2, arg3, arg4)
#define trace5(format, arg1, arg2, arg3, arg4, arg5)
#define debug(statement)

#endif


#if 0 /* gp */
int f(int i) {
    require(0 <= i); // ̊֐vdl
    require_(0 <= i,"i ͐̐");  // bZ[WĂǂ

    assert(0 == 1 - 1);   // ^\

    int out = i + 10;
    int* p = new int [i];
    mem_assert(p);   // Ȃ΂ŏI

    ensure(out == i + 10); // ̊֐ۏ؂dl
    ensure_(10 <= out, "out ͐̐");
    return out;
}
int main(void) {
    f(1); // ok
    f(-1); // eror;
    f(30000000000000); // mem_assert ŏI
}
#endif

#endif 	/* !defined(tjdebug_h) */
